C (c) CROWN COPYRIGHT 1995, METEOROLOGICAL OFFICE, All Rights Reserved.            RAD_ALL.18856 
C                                                                                  RAD_ALL.18857 
C Use, duplication or disclosure of this code is subject to the                    RAD_ALL.18858 
C restrictions as set forth in the contract.                                       RAD_ALL.18859 
C                                                                                  RAD_ALL.18860 
C                Meteorological Office                                             RAD_ALL.18861 
C                London Road                                                       RAD_ALL.18862 
C                BRACKNELL                                                         RAD_ALL.18863 
C                Berkshire UK                                                      RAD_ALL.18864 
C                RG12 2SZ                                                          RAD_ALL.18865 
C                                                                                  RAD_ALL.18866 
C If no contract has been raised with this copy of the code, the use,              RAD_ALL.18867 
C duplication or disclosure of it is strictly prohibited.  Permission              RAD_ALL.18868 
C to do so must first be obtained in writing from the Head of Numerical            RAD_ALL.18869 
C Modelling at the above address.                                                  RAD_ALL.18870 
C ******************************COPYRIGHT******************************            RAD_ALL.18871 
C                                                                                  RAD_ALL.18872 
!+ Subroutine to set pointers to types of clouds                                   RAD_ALL.18873 
!                                                                                  RAD_ALL.18874 
! Method:                                                                          RAD_ALL.18875 
!       The types of condensate included are examined. Their phases                RAD_ALL.18876 
!       are set and depending on the representation of clouds adopted              RAD_ALL.18877 
!       it is determined to which type of cloud they contribute.                   RAD_ALL.18878 
!                                                                                  RAD_ALL.18879 
! Current Owner of Code: J. M. Edwards                                             RAD_ALL.18880 
!                                                                                  RAD_ALL.18881 
! History:                                                                         RAD_ALL.18882 
!       Version         Date                    Comment                            RAD_ALL.18883 
!       4.0             27-07-95                Original Code                      RAD_ALL.18884 
!                                               (J. M. Edwards)                    RAD_ALL.18885 
!                                                                                  RAD_ALL.18886 
! Description of Code:                                                             RAD_ALL.18887 
!   FORTRAN 77  with extensions listed in documentation.                           RAD_ALL.18888 
!                                                                                  RAD_ALL.18889 
!- ---------------------------------------------------------------------           RAD_ALL.18890 
      SUBROUTINE SET_CLOUD_POINTER(IERR                                            RAD_ALL.18891 
     &   , N_CONDENSED, TYPE_CONDENSED, I_CLOUD_REPRESENTATION                     RAD_ALL.18892 
     &   , L_DROP, L_ICE                                                           RAD_ALL.18893 
     &   , I_PHASE_CMP, I_CLOUD_TYPE, L_CLOUD_CMP                                  RAD_ALL.18894 
     &   )                                                                         RAD_ALL.18895 
!                                                                                  RAD_ALL.18896 
!                                                                                  RAD_ALL.18897 
!                                                                                  RAD_ALL.18898 
      IMPLICIT NONE                                                                RAD_ALL.18899 
!                                                                                  RAD_ALL.18900 
!                                                                                  RAD_ALL.18901 
!                                                                                  RAD_ALL.18902 
!     INCLUDE COMDECKS                                                             RAD_ALL.18903 
!     ------------------------------------------------------------------           STDIO3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       STDIO3A.3     
!                                                                                  STDIO3A.4     
!     MODULE TO SET UNIT NUMBERS FOR STANDARD I/O.                                 STDIO3A.5     
!                                                                                  STDIO3A.6     
      INTEGER                                                                      STDIO3A.7     
     &     IU_STDIN                                                                STDIO3A.8     
!             UNIT NUMBER FOR STANDARD INPUT                                       STDIO3A.9     
     &   , IU_STDOUT                                                               STDIO3A.10    
!             UNIT NUMBER FOR STANDARD OUTPUT                                      STDIO3A.11    
     *   , IU_ERR                                                                  STDIO3A.12    
!             UNIT NUMBER FOR ERROR MESSAGES                                       STDIO3A.13    
!                                                                                  STDIO3A.14    
      PARAMETER(                                                                   STDIO3A.15    
     &     IU_STDIN=5                                                              STDIO3A.16    
     &   , IU_STDOUT=6                                                             STDIO3A.17    
     *   , IU_ERR=6                                                                STDIO3A.18    
     &   )                                                                         STDIO3A.19    
!                                                                                  STDIO3A.20    
!     ------------------------------------------------------------------           STDIO3A.21    
!     ------------------------------------------------------------------           ERROR3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       ERROR3A.3     
!                                                                                  ERROR3A.4     
!     MODULE TO SET ERROR FLAGS IN THE RADIATION CODE.                             ERROR3A.5     
!                                                                                  ERROR3A.6     
      INTEGER                                                                      ERROR3A.7     
     &     I_NORMAL                                                                ERROR3A.8     
!             ERROR FREE CONDITION                                                 ERROR3A.9     
     &   , I_ERR_FATAL                                                             ERROR3A.10    
!             FATAL ERROR: IMMEDIATE RETURN                                        ERROR3A.11    
     &   , I_ABORT_CALCULATION                                                     ERROR3A.12    
!             CALCULATION ABORTED                                                  ERROR3A.13    
     &   , I_MISSING_DATA                                                          ERROR3A.14    
!             MISSING DATA ERROR: CONDITIONAL                                      ERROR3A.15    
     &   , I_ERR_IO                                                                ERROR3A.16    
!             I/O ERROR                                                            ERROR3A.17    
     &   , I_ERR_RANGE                                                             ERROR3A.18    
!             INTERPOLATION RANGE ERROR                                            ERROR3A.19    
     &   , I_ERR_EXIST                                                             ERROR3A.20    
!             EXISTENCE ERROR                                                      ERROR3A.21    
!                                                                                  ERROR3A.22    
      PARAMETER(                                                                   ERROR3A.23    
     &     I_NORMAL=0                                                              ERROR3A.24    
     &   , I_ERR_FATAL=1                                                           ERROR3A.25    
     &   , I_ABORT_CALCULATION=2                                                   ERROR3A.26    
     &   , I_MISSING_DATA=3                                                        ERROR3A.27    
     &   , I_ERR_IO=4                                                              ERROR3A.28    
     &   , I_ERR_RANGE=5                                                           ERROR3A.29    
     &   , I_ERR_EXIST=6                                                           ERROR3A.30    
     &   )                                                                         ERROR3A.31    
!                                                                                  ERROR3A.32    
!     ------------------------------------------------------------------           ERROR3A.33    
!     ------------------------------------------------------------------           DIMFIX3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       DIMFIX3A.3     
!                                                                                  DIMFIX3A.4     
!     MODULE TO SET INTERNAL DIMENSIONS TIED TO ALGORITHMS,                        DIMFIX3A.5     
!     MOSTLY FOR CLOUDS.                                                           DIMFIX3A.6     
!                                                                                  DIMFIX3A.7     
      INTEGER                                                                      DIMFIX3A.8     
     &     NPD_CLOUD_COMPONENT                                                     DIMFIX3A.9     
!             NUMBER OF COMPONENTS OF CLOUDS                                       DIMFIX3A.10    
     &   , NPD_CLOUD_TYPE                                                          DIMFIX3A.11    
!             NUMBER OF PERMITTED TYPES OF CLOUDS.                                 DIMFIX3A.12    
     &   , NPD_CLOUD_REPRESENTATION                                                DIMFIX3A.13    
!             NUMBER OF PERMITTED REPRESENTATIONS OF CLOUDS.                       DIMFIX3A.14    
     &   , NPD_OVERLAP_COEFF                                                       DIMFIX3A.15    
!             NUMBER OF OVERLAP COEFFICIENTS FOR CLOUDS                            DIMFIX3A.16    
     &   , NPD_SOURCE_COEFF                                                        DIMFIX3A.17    
!             NUMBER OF COEFFICIENTS FOR TWO-STREAM SOURCES                        DIMFIX3A.18    
     &   , NPD_REGION                                                              DIMFIX3A.19    
!             NUMBER OF REGIONS IN A LAYER                                         DIMFIX3A.20    
!                                                                                  DIMFIX3A.21    
      PARAMETER(                                                                   DIMFIX3A.22    
     &     NPD_CLOUD_COMPONENT=4                                                   DIMFIX3A.23    
     &   , NPD_CLOUD_TYPE=4                                                        DIMFIX3A.24    
     &   , NPD_CLOUD_REPRESENTATION=4                                              DIMFIX3A.25    
     &   , NPD_OVERLAP_COEFF=18                                                    DIMFIX3A.26    
     &   , NPD_SOURCE_COEFF=2                                                      DIMFIX3A.27    
     &   , NPD_REGION=3                                                            DIMFIX3A.28    
     &   )                                                                         DIMFIX3A.29    
!                                                                                  DIMFIX3A.30    
!     ------------------------------------------------------------------           DIMFIX3A.31    
!     ------------------------------------------------------------------           PHASE3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       PHASE3A.3     
!                                                                                  PHASE3A.4     
!     MODULE TO SET INDICES FOR PHASES.                                            PHASE3A.5     
!                                                                                  PHASE3A.6     
      INTEGER                                                                      PHASE3A.7     
     &     IP_PHASE_WATER                                                          PHASE3A.8     
!             LIQUID PHASE                                                         PHASE3A.9     
     &   , IP_PHASE_ICE                                                            PHASE3A.10    
!             ICE PHASE                                                            PHASE3A.11    
!                                                                                  PHASE3A.12    
      PARAMETER(                                                                   PHASE3A.13    
     &     IP_PHASE_WATER=1                                                        PHASE3A.14    
     &   , IP_PHASE_ICE=2                                                          PHASE3A.15    
     &   )                                                                         PHASE3A.16    
!                                                                                  PHASE3A.17    
!     ------------------------------------------------------------------           PHASE3A.18    
!     ------------------------------------------------------------------           CLDCMP3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       CLDCMP3A.3     
!                                                                                  CLDCMP3A.4     
!     MODULE TO SET COMPONENTS OF CLOUDS.                                          CLDCMP3A.5     
!                                                                                  CLDCMP3A.6     
      INTEGER                                                                      CLDCMP3A.7     
     &     IP_CLCMP_ST_WATER                                                       CLDCMP3A.8     
!             STRATIFORM WATER DROPLETS                                            CLDCMP3A.9     
     &   , IP_CLCMP_ST_ICE                                                         CLDCMP3A.10    
!             STRATIFORM ICE CRYSTALS                                              CLDCMP3A.11    
     &   , IP_CLCMP_CNV_WATER                                                      CLDCMP3A.12    
!             CONVECTIVE WATER DROPLETS                                            CLDCMP3A.13    
     &   , IP_CLCMP_CNV_ICE                                                        CLDCMP3A.14    
!             CONVECTIVE ICE CRYSTALS                                              CLDCMP3A.15    
!                                                                                  CLDCMP3A.16    
      PARAMETER(                                                                   CLDCMP3A.17    
     &     IP_CLCMP_ST_WATER=1                                                     CLDCMP3A.18    
     &   , IP_CLCMP_ST_ICE=2                                                       CLDCMP3A.19    
     &   , IP_CLCMP_CNV_WATER=3                                                    CLDCMP3A.20    
     &   , IP_CLCMP_CNV_ICE=4                                                      CLDCMP3A.21    
     &   )                                                                         CLDCMP3A.22    
!                                                                                  CLDCMP3A.23    
!     ------------------------------------------------------------------           CLDCMP3A.24    
!     ------------------------------------------------------------------           CLREPP3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       CLREPP3A.3     
!                                                                                  CLREPP3A.4     
!     MODULE TO SET REPRESENTATIONS OF CLOUDS.                                     CLREPP3A.5     
!                                                                                  CLREPP3A.6     
!     REPRESENTATIONS                                                              CLREPP3A.7     
      INTEGER                                                                      CLREPP3A.8     
     &     IP_CLOUD_HOMOGEN                                                        CLREPP3A.9     
!             ALL COMPONENTS ARE MIXED HOMOGENEOUSLY                               CLREPP3A.10    
     &   , IP_CLOUD_ICE_WATER                                                      CLREPP3A.11    
!             ICE AND WATER CLOUDS ARE TREATED SEPARATELY                          CLREPP3A.12    
     &   , IP_CLOUD_CONV_STRAT                                                     CLREPP3A.13    
!             CLOUDS ARE DIVIDED INTO HOMOGENEOUSLY MIXED                          CLREPP3A.14    
!             STRATIFORM AND CONVECTIVE PARTS                                      CLREPP3A.15    
     &   , IP_CLOUD_CSIW                                                           CLREPP3A.16    
!             CLOUDS DIVIDED INTO ICE AND WATER PHASES AND                         CLREPP3A.17    
!             INTO STRATIFORM AND CONVECTIVE COMPONENTS.                           CLREPP3A.18    
!                                                                                  CLREPP3A.19    
      PARAMETER(                                                                   CLREPP3A.20    
     &     IP_CLOUD_HOMOGEN=1                                                      CLREPP3A.21    
     &   , IP_CLOUD_ICE_WATER=2                                                    CLREPP3A.22    
     &   , IP_CLOUD_CONV_STRAT=3                                                   CLREPP3A.23    
     &   , IP_CLOUD_CSIW=4                                                         CLREPP3A.24    
     &   )                                                                         CLREPP3A.25    
!                                                                                  CLREPP3A.26    
!     TYPES OF CLOUDS:                                                             CLREPP3A.27    
      INTEGER                                                                      CLREPP3A.28    
     &     NP_CLOUD_TYPE(NPD_CLOUD_REPRESENTATION)                                 CLREPP3A.29    
!             NUMBER OF TYPE OF CLOUDS IN REPRESENTATION                           CLREPP3A.30    
!                                                                                  CLREPP3A.31    
      INTEGER                                                                      CLREPP3A.32    
     &     IP_CLOUD_TYPE_MAP(NPD_CLOUD_COMPONENT                                   CLREPP3A.33    
     &       , NPD_CLOUD_REPRESENTATION)                                           CLREPP3A.34    
!            MAP OF COMPONENTS CONTRIBUTING TO TYPES OF CLOUDS                     CLREPP3A.35    
!                                                                                  CLREPP3A.36    
!     ------------------------------------------------------------------           CLREPP3A.37    
!     ------------------------------------------------------------------           CLDTYP3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       CLDTYP3A.3     
!                                                                                  CLDTYP3A.4     
!     MODULE TO SET TYPES OF CLOUDS.                                               CLDTYP3A.5     
!                                                                                  CLDTYP3A.6     
      INTEGER                                                                      CLDTYP3A.7     
     &     IP_CLOUD_TYPE_HOMOGEN                                                   CLDTYP3A.8     
!             CLOUD COMPOSED OF MIXED WATER AND ICE                                CLDTYP3A.9     
     &   , IP_CLOUD_TYPE_WATER                                                     CLDTYP3A.10    
!             CLOUD COMPOSED ONLY OF WATER                                         CLDTYP3A.11    
     &   , IP_CLOUD_TYPE_ICE                                                       CLDTYP3A.12    
!             CLOUD COMPOSED ONLY OF ICE                                           CLDTYP3A.13    
     &   , IP_CLOUD_TYPE_STRAT                                                     CLDTYP3A.14    
!             MIXED-PHASE STRATIFORM CLOUD                                         CLDTYP3A.15    
     &   , IP_CLOUD_TYPE_CONV                                                      CLDTYP3A.16    
!             MIXED-PHASE CONVECTIVE CLOUD                                         CLDTYP3A.17    
     &   , IP_CLOUD_TYPE_SW                                                        CLDTYP3A.18    
!             STRATIFORM WATER CLOUD                                               CLDTYP3A.19    
     &   , IP_CLOUD_TYPE_SI                                                        CLDTYP3A.20    
!             STRATIFORM ICE CLOUD                                                 CLDTYP3A.21    
     &   , IP_CLOUD_TYPE_CW                                                        CLDTYP3A.22    
!             CONVECTIVE WATER CLOUD                                               CLDTYP3A.23    
     &   , IP_CLOUD_TYPE_CI                                                        CLDTYP3A.24    
!             CONVECTIVE ICE CLOUD                                                 CLDTYP3A.25    
!                                                                                  CLDTYP3A.26    
      PARAMETER(                                                                   CLDTYP3A.27    
     &     IP_CLOUD_TYPE_HOMOGEN=1                                                 CLDTYP3A.28    
     &   , IP_CLOUD_TYPE_WATER=1                                                   CLDTYP3A.29    
     &   , IP_CLOUD_TYPE_ICE=2                                                     CLDTYP3A.30    
     &   , IP_CLOUD_TYPE_STRAT=1                                                   CLDTYP3A.31    
     &   , IP_CLOUD_TYPE_CONV=2                                                    CLDTYP3A.32    
     &   , IP_CLOUD_TYPE_SW=1                                                      CLDTYP3A.33    
     &   , IP_CLOUD_TYPE_SI=2                                                      CLDTYP3A.34    
     &   , IP_CLOUD_TYPE_CW=3                                                      CLDTYP3A.35    
     &   , IP_CLOUD_TYPE_CI=4                                                      CLDTYP3A.36    
     &   )                                                                         CLDTYP3A.37    
!                                                                                  CLDTYP3A.38    
!     ------------------------------------------------------------------           CLDTYP3A.39    
!                                                                                  RAD_ALL.18911 
!     DUMMY VARIABLES.                                                             RAD_ALL.18912 
      INTEGER   !, INTENT(OUT)                                                     RAD_ALL.18913 
     &     IERR                                                                    RAD_ALL.18914 
!             ERROR FLAG                                                           RAD_ALL.18915 
      INTEGER   !, INTENT(IN)                                                      RAD_ALL.18916 
     &     N_CONDENSED                                                             RAD_ALL.18917 
!             NUMBER OF CONDENSED COMPONENTS                                       RAD_ALL.18918 
     &   , TYPE_CONDENSED(NPD_CLOUD_COMPONENT)                                     RAD_ALL.18919 
!             TYPES OF COMPONENTS                                                  RAD_ALL.18920 
     &   , I_CLOUD_REPRESENTATION                                                  RAD_ALL.18921 
!             REPRESENTATION OF CLOUDS USED                                        RAD_ALL.18922 
      LOGICAL   !, INTENT(IN)                                                      RAD_ALL.18923 
     &     L_DROP                                                                  RAD_ALL.18924 
!             FLAG FOR INCLUSION OF DROPLETS                                       RAD_ALL.18925 
     &   , L_ICE                                                                   RAD_ALL.18926 
!             FLAG FOR INCLUSION OF ICE CRYSTALS                                   RAD_ALL.18927 
!                                                                                  RAD_ALL.18928 
      INTEGER   !, INTENT(OUT)                                                     RAD_ALL.18929 
     &     I_PHASE_CMP(NPD_CLOUD_COMPONENT)                                        RAD_ALL.18930 
!             PHASES OF COMPONENTS                                                 RAD_ALL.18931 
     &   , I_CLOUD_TYPE(NPD_CLOUD_COMPONENT)                                       RAD_ALL.18932 
!             TYPES OF CLOUD TO WHICH EACH COMPONENT CONTRIBUTES                   RAD_ALL.18933 
      LOGICAL   !, INTENT(OUT)                                                     RAD_ALL.18934 
     &     L_CLOUD_CMP(NPD_CLOUD_COMPONENT)                                        RAD_ALL.18935 
!             LOGICAL SWITCHES TO INCLUDE COMPONENTS                               RAD_ALL.18936 
!                                                                                  RAD_ALL.18937 
!                                                                                  RAD_ALL.18938 
!     LOCAL VARIABLES                                                              RAD_ALL.18939 
      INTEGER                                                                      RAD_ALL.18940 
     &     K                                                                       RAD_ALL.18941 
!            LOOP VARIABLE                                                         RAD_ALL.18942 
!                                                                                  RAD_ALL.18943 
!     ------------------------------------------------------------------           CLREPD3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       CLREPD3A.3     
!                                                                                  CLREPD3A.4     
!     MODULE TO SET PROPERTIES OF REPRESENTATIONS OF CLOUDS.                       CLREPD3A.5     
!                                                                                  CLREPD3A.6     
      DATA                                                                         CLREPD3A.7     
     &    NP_CLOUD_TYPE(IP_CLOUD_HOMOGEN)/1/                                       CLREPD3A.8     
     &  , NP_CLOUD_TYPE(IP_CLOUD_ICE_WATER)/2/                                     CLREPD3A.9     
     &  , NP_CLOUD_TYPE(IP_CLOUD_CONV_STRAT)/2/                                    CLREPD3A.10    
     &  , NP_CLOUD_TYPE(IP_CLOUD_CSIW)/4/                                          CLREPD3A.11    
!                                                                                  CLREPD3A.12    
!                                                                                  CLREPD3A.13    
!     THE ARRAY IP_CLOUD_TYPE_MAP INDICATES TO WHICH TYPE OF CLOUD                 CLREPD3A.14    
!     EACH COMPONENT BELONGS IN A PARTICULAR REPRESENTATION. AN                    CLREPD3A.15    
!     ENTRY OF 0 INDICATES THAT THAT COMPONENT SHOULD NOT BE                       CLREPD3A.16    
!     PRESENT IN THE REPRESENTATION.                                               CLREPD3A.17    
!                                                                                  CLREPD3A.18    
      DATA                                                                         CLREPD3A.19    
     &    IP_CLOUD_TYPE_MAP(IP_CLCMP_ST_WATER, IP_CLOUD_HOMOGEN)                   CLREPD3A.20    
     &       /IP_CLOUD_TYPE_HOMOGEN/                                               CLREPD3A.21    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_ST_ICE, IP_CLOUD_HOMOGEN)                     CLREPD3A.22    
     &       /IP_CLOUD_TYPE_HOMOGEN/                                               CLREPD3A.23    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_CNV_WATER, IP_CLOUD_HOMOGEN)                  CLREPD3A.24    
     &       /0/                                                                   CLREPD3A.25    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_CNV_ICE, IP_CLOUD_HOMOGEN)                    CLREPD3A.26    
     &       /0/                                                                   CLREPD3A.27    
      DATA                                                                         CLREPD3A.28    
     &    IP_CLOUD_TYPE_MAP(IP_CLCMP_ST_WATER, IP_CLOUD_ICE_WATER)                 CLREPD3A.29    
     &       /IP_CLOUD_TYPE_WATER/                                                 CLREPD3A.30    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_ST_ICE, IP_CLOUD_ICE_WATER)                   CLREPD3A.31    
     &       /IP_CLOUD_TYPE_ICE/                                                   CLREPD3A.32    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_CNV_WATER, IP_CLOUD_ICE_WATER)                CLREPD3A.33    
     &       /0/                                                                   CLREPD3A.34    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_CNV_ICE, IP_CLOUD_ICE_WATER)                  CLREPD3A.35    
     &       /0/                                                                   CLREPD3A.36    
      DATA                                                                         CLREPD3A.37    
     &    IP_CLOUD_TYPE_MAP(IP_CLCMP_ST_WATER, IP_CLOUD_CONV_STRAT)                CLREPD3A.38    
     &       /IP_CLOUD_TYPE_STRAT/                                                 CLREPD3A.39    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_ST_ICE, IP_CLOUD_CONV_STRAT)                  CLREPD3A.40    
     &       /IP_CLOUD_TYPE_CONV/                                                  CLREPD3A.41    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_CNV_WATER, IP_CLOUD_CONV_STRAT)               CLREPD3A.42    
     &       /IP_CLOUD_TYPE_STRAT/                                                 CLREPD3A.43    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_CNV_ICE, IP_CLOUD_CONV_STRAT)                 CLREPD3A.44    
     &       /IP_CLOUD_TYPE_CONV/                                                  CLREPD3A.45    
      DATA                                                                         CLREPD3A.46    
     &    IP_CLOUD_TYPE_MAP(IP_CLCMP_ST_WATER, IP_CLOUD_CSIW)                      CLREPD3A.47    
     &       /IP_CLOUD_TYPE_SW/                                                    CLREPD3A.48    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_ST_ICE, IP_CLOUD_CSIW)                        CLREPD3A.49    
     &       /IP_CLOUD_TYPE_SI/                                                    CLREPD3A.50    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_CNV_WATER, IP_CLOUD_CSIW)                     CLREPD3A.51    
     &       /IP_CLOUD_TYPE_CW/                                                    CLREPD3A.52    
     &  , IP_CLOUD_TYPE_MAP(IP_CLCMP_CNV_ICE, IP_CLOUD_CSIW)                       CLREPD3A.53    
     &       /IP_CLOUD_TYPE_CI/                                                    CLREPD3A.54    
!                                                                                  CLREPD3A.55    
!     ------------------------------------------------------------------           CLREPD3A.56    
!                                                                                  RAD_ALL.18945 
!                                                                                  RAD_ALL.18946 
!                                                                                  RAD_ALL.18947 
      DO K=1, N_CONDENSED                                                          RAD_ALL.18948 
!                                                                                  RAD_ALL.18949 
         I_CLOUD_TYPE(K)=IP_CLOUD_TYPE_MAP(TYPE_CONDENSED(K)                       RAD_ALL.18950 
     &      , I_CLOUD_REPRESENTATION)                                              RAD_ALL.18951 
!                                                                                  RAD_ALL.18952 
!        CHECK FOR 0 FLAGGING ILLEGAL TYPES.                                       RAD_ALL.18953 
         IF (I_CLOUD_TYPE(K).EQ.0) THEN                                            RAD_ALL.18954 
            WRITE(IU_ERR, '(/A)')                                                  RAD_ALL.18955 
     &         '*** ERROR: A COMPONENT IS NOT COMPATIBLE WITH THE'                 RAD_ALL.18956 
     &         //'REPRESENTATION OF CLOUDS SELECTED.'                              RAD_ALL.18957 
            IERR=I_ERR_FATAL                                                       RAD_ALL.18958 
            RETURN                                                                 RAD_ALL.18959 
         ENDIF                                                                     RAD_ALL.18960 
!                                                                                  RAD_ALL.18961 
         IF (TYPE_CONDENSED(K).EQ.IP_CLCMP_ST_WATER) THEN                          RAD_ALL.18962 
!                                                                                  RAD_ALL.18963 
            I_PHASE_CMP(K)=IP_PHASE_WATER                                          RAD_ALL.18964 
            L_CLOUD_CMP(K)=L_DROP                                                  RAD_ALL.18965 
!                                                                                  RAD_ALL.18966 
         ELSE IF (TYPE_CONDENSED(K).EQ.IP_CLCMP_ST_ICE) THEN                       RAD_ALL.18967 
!                                                                                  RAD_ALL.18968 
            I_PHASE_CMP(K)=IP_PHASE_ICE                                            RAD_ALL.18969 
            L_CLOUD_CMP(K)=L_ICE                                                   RAD_ALL.18970 
!                                                                                  RAD_ALL.18971 
         ELSE IF (TYPE_CONDENSED(K).EQ.IP_CLCMP_CNV_WATER) THEN                    RAD_ALL.18972 
!                                                                                  RAD_ALL.18973 
            I_PHASE_CMP(K)=IP_PHASE_WATER                                          RAD_ALL.18974 
            L_CLOUD_CMP(K)=L_DROP                                                  RAD_ALL.18975 
!                                                                                  RAD_ALL.18976 
         ELSE IF (TYPE_CONDENSED(K).EQ.IP_CLCMP_CNV_ICE) THEN                      RAD_ALL.18977 
!                                                                                  RAD_ALL.18978 
            I_PHASE_CMP(K)=IP_PHASE_ICE                                            RAD_ALL.18979 
            L_CLOUD_CMP(K)=L_ICE                                                   RAD_ALL.18980 
!                                                                                  RAD_ALL.18981 
         ENDIF                                                                     RAD_ALL.18982 
!                                                                                  RAD_ALL.18983 
      ENDDO                                                                        RAD_ALL.18984 
!                                                                                  RAD_ALL.18985 
!                                                                                  RAD_ALL.18986 
!                                                                                  RAD_ALL.18987 
      RETURN                                                                       RAD_ALL.18988 
      END   
